const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');

const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class InfractionsDBApi {
  static async create(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const infractions = await db.infractions.create(
      {
        id: data.id || undefined,

        ref_no: data.ref_no || null,
        date: data.date || null,
        location: data.location || null,
        amount: data.amount || null,
        status: data.status || null,
        proof_url: data.proof_url || null,
        importHash: data.importHash || null,
        createdById: currentUser.id,
        updatedById: currentUser.id,
      },
      { transaction },
    );

    await infractions.setTenant(data.tenant || null, {
      transaction,
    });

    await infractions.setVehicle(data.vehicle || null, {
      transaction,
    });

    await infractions.setReservation(data.reservation || null, {
      transaction,
    });

    await infractions.setAgences(data.agences || null, {
      transaction,
    });

    return infractions;
  }

  static async bulkImport(data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    // Prepare data - wrapping individual data transformations in a map() method
    const infractionsData = data.map((item, index) => ({
      id: item.id || undefined,

      ref_no: item.ref_no || null,
      date: item.date || null,
      location: item.location || null,
      amount: item.amount || null,
      status: item.status || null,
      proof_url: item.proof_url || null,
      importHash: item.importHash || null,
      createdById: currentUser.id,
      updatedById: currentUser.id,
      createdAt: new Date(Date.now() + index * 1000),
    }));

    // Bulk create items
    const infractions = await db.infractions.bulkCreate(infractionsData, {
      transaction,
    });

    // For each item created, replace relation files

    return infractions;
  }

  static async update(id, data, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;
    const globalAccess = currentUser.app_role?.globalAccess;

    const infractions = await db.infractions.findByPk(id, {}, { transaction });

    const updatePayload = {};

    if (data.ref_no !== undefined) updatePayload.ref_no = data.ref_no;

    if (data.date !== undefined) updatePayload.date = data.date;

    if (data.location !== undefined) updatePayload.location = data.location;

    if (data.amount !== undefined) updatePayload.amount = data.amount;

    if (data.status !== undefined) updatePayload.status = data.status;

    if (data.proof_url !== undefined) updatePayload.proof_url = data.proof_url;

    updatePayload.updatedById = currentUser.id;

    await infractions.update(updatePayload, { transaction });

    if (data.tenant !== undefined) {
      await infractions.setTenant(
        data.tenant,

        { transaction },
      );
    }

    if (data.vehicle !== undefined) {
      await infractions.setVehicle(
        data.vehicle,

        { transaction },
      );
    }

    if (data.reservation !== undefined) {
      await infractions.setReservation(
        data.reservation,

        { transaction },
      );
    }

    if (data.agences !== undefined) {
      await infractions.setAgences(
        data.agences,

        { transaction },
      );
    }

    return infractions;
  }

  static async deleteByIds(ids, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const infractions = await db.infractions.findAll({
      where: {
        id: {
          [Op.in]: ids,
        },
      },
      transaction,
    });

    await db.sequelize.transaction(async (transaction) => {
      for (const record of infractions) {
        await record.update({ deletedBy: currentUser.id }, { transaction });
      }
      for (const record of infractions) {
        await record.destroy({ transaction });
      }
    });

    return infractions;
  }

  static async remove(id, options) {
    const currentUser = (options && options.currentUser) || { id: null };
    const transaction = (options && options.transaction) || undefined;

    const infractions = await db.infractions.findByPk(id, options);

    await infractions.update(
      {
        deletedBy: currentUser.id,
      },
      {
        transaction,
      },
    );

    await infractions.destroy({
      transaction,
    });

    return infractions;
  }

  static async findBy(where, options) {
    const transaction = (options && options.transaction) || undefined;

    const infractions = await db.infractions.findOne(
      { where },
      { transaction },
    );

    if (!infractions) {
      return infractions;
    }

    const output = infractions.get({ plain: true });

    output.tenant = await infractions.getTenant({
      transaction,
    });

    output.vehicle = await infractions.getVehicle({
      transaction,
    });

    output.reservation = await infractions.getReservation({
      transaction,
    });

    output.agences = await infractions.getAgences({
      transaction,
    });

    return output;
  }

  static async findAll(filter, globalAccess, options) {
    const limit = filter.limit || 0;
    let offset = 0;
    let where = {};
    const currentPage = +filter.page;

    const user = (options && options.currentUser) || null;
    const userAgences = (user && user.agences?.id) || null;

    if (userAgences) {
      if (options?.currentUser?.agencesId) {
        where.agencesId = options.currentUser.agencesId;
      }
    }

    offset = currentPage * limit;

    const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [
      {
        model: db.tenants,
        as: 'tenant',

        where: filter.tenant
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.tenant
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  name: {
                    [Op.or]: filter.tenant
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.vehicles,
        as: 'vehicle',

        where: filter.vehicle
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.vehicle
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  plate_number: {
                    [Op.or]: filter.vehicle
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.reservations,
        as: 'reservation',

        where: filter.reservation
          ? {
              [Op.or]: [
                {
                  id: {
                    [Op.in]: filter.reservation
                      .split('|')
                      .map((term) => Utils.uuid(term)),
                  },
                },
                {
                  ref: {
                    [Op.or]: filter.reservation
                      .split('|')
                      .map((term) => ({ [Op.iLike]: `%${term}%` })),
                  },
                },
              ],
            }
          : {},
      },

      {
        model: db.agences,
        as: 'agences',
      },
    ];

    if (filter) {
      if (filter.id) {
        where = {
          ...where,
          ['id']: Utils.uuid(filter.id),
        };
      }

      if (filter.ref_no) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('infractions', 'ref_no', filter.ref_no),
        };
      }

      if (filter.location) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('infractions', 'location', filter.location),
        };
      }

      if (filter.proof_url) {
        where = {
          ...where,
          [Op.and]: Utils.ilike('infractions', 'proof_url', filter.proof_url),
        };
      }

      if (filter.dateRange) {
        const [start, end] = filter.dateRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            date: {
              ...where.date,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            date: {
              ...where.date,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.amountRange) {
        const [start, end] = filter.amountRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            amount: {
              ...where.amount,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            amount: {
              ...where.amount,
              [Op.lte]: end,
            },
          };
        }
      }

      if (filter.active !== undefined) {
        where = {
          ...where,
          active: filter.active === true || filter.active === 'true',
        };
      }

      if (filter.status) {
        where = {
          ...where,
          status: filter.status,
        };
      }

      if (filter.agences) {
        const listItems = filter.agences.split('|').map((item) => {
          return Utils.uuid(item);
        });

        where = {
          ...where,
          agencesId: { [Op.or]: listItems },
        };
      }

      if (filter.createdAtRange) {
        const [start, end] = filter.createdAtRange;

        if (start !== undefined && start !== null && start !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.gte]: start,
            },
          };
        }

        if (end !== undefined && end !== null && end !== '') {
          where = {
            ...where,
            ['createdAt']: {
              ...where.createdAt,
              [Op.lte]: end,
            },
          };
        }
      }
    }

    if (globalAccess) {
      delete where.agencesId;
    }

    const queryOptions = {
      where,
      include,
      distinct: true,
      order:
        filter.field && filter.sort
          ? [[filter.field, filter.sort]]
          : [['createdAt', 'desc']],
      transaction: options?.transaction,
      logging: console.log,
    };

    if (!options?.countOnly) {
      queryOptions.limit = limit ? Number(limit) : undefined;
      queryOptions.offset = offset ? Number(offset) : undefined;
    }

    try {
      const { rows, count } = await db.infractions.findAndCountAll(
        queryOptions,
      );

      return {
        rows: options?.countOnly ? [] : rows,
        count: count,
      };
    } catch (error) {
      console.error('Error executing query:', error);
      throw error;
    }
  }

  static async findAllAutocomplete(
    query,
    limit,
    offset,
    globalAccess,
    organizationId,
  ) {
    let where = {};

    if (!globalAccess && organizationId) {
      where.organizationId = organizationId;
    }

    if (query) {
      where = {
        [Op.or]: [
          { ['id']: Utils.uuid(query) },
          Utils.ilike('infractions', 'ref_no', query),
        ],
      };
    }

    const records = await db.infractions.findAll({
      attributes: ['id', 'ref_no'],
      where,
      limit: limit ? Number(limit) : undefined,
      offset: offset ? Number(offset) : undefined,
      orderBy: [['ref_no', 'ASC']],
    });

    return records.map((record) => ({
      id: record.id,
      label: record.ref_no,
    }));
  }
};
